<?php
/**
* This file is part of the Agora-Project Software package.
*
* @copyright (c) Agora-Project Limited <https://www.agora-project.net>
* @license GNU General Public License, version 2 (GPL-2.0)
*/


/*
 * Controleur du module "Message"
 */
class CtrlMessage extends Ctrl
{
	const moduleName="message";
	
	public static $MdlObjects=array("MdlMessage");
		
	/*
	 * ACTION PAR DEFAUT
	*/
	public static function actionDefault()
	{
		// INIT
		static::$isMainPage=true;
		
		////	STATUTE ET TARGET : 0:DRAFTS, 1:SENDBOX, 2:INBOX , 3:ARCHIVES, 4:BIN, 5:EN ATTENT DE SUPPRESSION
		
		// RECUPERATION TARGET
		If (Req::isParam("target")) {$target=Req::getParam("target");} else {$target="inbox";}
		$vDatas["target"]=$target;
		$statute="";
		// RECUPERATION ALPHABET
		$sqlAlphabetFilter=(Req::isParam("alphabet")) ? "AND `object` LIKE '".Req::getParam("alphabet")."%'" : null;
			
		// DRAFT STATUTE:0
		If($target=="drafts")
		{
			$sqltarget="WHERE `_idSender`=".Ctrl::$curUser->_id."";
			$statute="AND `statute`=0 ".$sqlAlphabetFilter."";
		}
			
		// SENDBOX INBOX:1
		If($target=="sendbox")
		{
			$sqltarget="WHERE `_idSender`=".Ctrl::$curUser->_id."";
			$statute="AND `statute`=1 ".$sqlAlphabetFilter."";
		}
		
		// INBOX STATUTE:2
		If($target=="inbox")
		{
			$sqltarget="WHERE `_idRecipient`=".Ctrl::$curUser->_id."";
			$statute="AND `statute`=2 ".$sqlAlphabetFilter."";
		} 
		
		// ARCHIVES STATUTE:3 //BIN STATUTE:4-5
		If(($target=="bin") || ($target=="archives"))
		{
			If($target=="bin") 
			{
				$statute_tmp=4;
			} 
			elseif($target=="archives")
			{
				$statute_tmp=3;
			}
			$sqltarget="WHERE (`_idSender`=".Ctrl::$curUser->_id." AND `statute`=".$statute_tmp." AND `_id`=`_idMessageSender` ".$sqlAlphabetFilter.") OR (`_idRecipient`=".Ctrl::$curUser->_id." AND `statute`=".$statute_tmp." AND `_id`<>`_idMessageSender` ".$sqlAlphabetFilter.")";
		}
			
		////	Filtre Alphabet : avec la première lettre du nom
		$vDatas["alphabetList"]=Db::getCol("SELECT DISTINCT UPPER(LEFT(`object`,1)) as initiale FROM ".MdlMessage::dbTable." ".$sqltarget." ".$statute." ORDER BY initiale");
			
		////	MESSAGES ET MENUS
		$sqlDisplayedMessages="SELECT * FROM ".MdlMessage::dbTable." ".$sqltarget." ".$statute." ".MdlMessage::sqlSort()."";
		$vDatas["displayedMessages"]=Db::getObjTab(MdlMessage::moduleName, $sqlDisplayedMessages." ".MdlMessage::sqlPagination().""); 
			
		////	Affiche normal de la page VueIndex.php
		static::displayPage("VueIndex.php",$vDatas);
	}

	/*
	 * ACTION mmessageEdit() : LECTURE DU MESSAGE
	*/
	public static function actionmessageEdit()
	{
		$curObj=Ctrl::getTargetObj();
		$curObj->controlRead();
		$vDatas["curObj"]=$curObj;
		$target=Req::getParam("target");
		$vDatas["target"]=$target;
		
		if (($curObj->_idRecipient)==(Ctrl::$curUser->_id))
		{
			Db::query("UPDATE ".MdlMessage::dbTable." SET `statuteRead`=1, `dateRead`=".Db::dateNow()." WHERE `_id`=".$curObj->_id."");
		}
		// Affichage de la page
		static::displayPage("VueMessage.php",$vDatas);
	}
	
	/*
	 * ACTION messageSend() : ENVOI DU MESSAGE OU BROUILLON DEPUIS VUEMESSAGEINABOTTLE.PHP
	*/
	public function actionmessageSend()
	{
		if((Req::isParam("formValidate","object","description") && (Req::isParam("personList") || Req::isParam("groupList"))) || Req::isParam("draft","object","description"))
		{
			
			//////	 ENVOI DEPUIS BROUILLON
			if(Req::isParam("draft","object","description"))
			{
				$iddradft_tmp=Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=0",true);
				Db::query("UPDATE ".MdlMessage::dbTable." SET `_idMessageSender`=".$iddradft_tmp." WHERE `_id`=".$iddradft_tmp."");
				self::redir('index.php?ctrl=message&target=drafts');
			}
			//////	 NOUVEAU MESSAGE
			elseif(Req::isParam("formValidate","object","description") && (Req::isParam("personList") || Req::isParam("groupList")))
			{
				////	Liste des destinataires : personList & groupes d'users
				$options=null;
				$txtMailTo=null;
			
				if(Req::getParam("hideRecipients"))	{$options=" ,`hideRecipients`=1";}
			
				//	Liste de personnes
				if(Req::isParam("personList"))
				{
					// INIT
					$cptPerson=0;
					$idtmpObj=null;
					$idtmpObj1=null;
					$idtmpDestinataires=null;
					
					foreach(Req::getParam("personList") as $tmpPerson)
					{
						$cptPerson++;
						//	RECUPERATION INFO USER
						$tmpPersonObj=Ctrl::getTargetObj($tmpPerson);
					
						//if ($cptPerson==1) {$options=$options.",_idFirstRecipient=".$tmpPersonObj->_id;}
				
						//	ENVOI DEPUIS BROUILLONS
						if(Req::getParam("ObjId"))
						{
							if ($cptPerson==1)
							{
								// ENREGISTREMENT TABLE MESSAGE EXPEDITEUR
								$idtmpObj=Req::getParam("ObjId");
								Db::query("UPDATE ".MdlMessage::dbTable." SET `_idMessageSender`=".$idtmpObj.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=1, `_idRecipient`=".$tmpPersonObj->_id.$options." WHERE `_id`=".Req::getParam("ObjId")."");
								// ENREGISTREMENT TABLE MESSAGE PREMIER DESTINATAIRE
									Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idMessageSender`=".$idtmpObj.", `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=2, `_idRecipient`=".$tmpPersonObj->_id.$options."");
							}
							else
							{
								//	ENREGISTREMENT TABLE MESSAGE DESTINATAIRES
								Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idMessageSender`=".$idtmpObj.", `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=2, `_idRecipient`=".$tmpPersonObj->_id.$options."");
							}
						}
					
						////	NOUVEAU MESSSAGE
						else
						{
							if ($cptPerson==1)
							{
								// ENREGISTREMENT TABLE MESSAGE EXPEDITEUR
								Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=1, `_idRecipient`=".$tmpPersonObj->_id.$options."");
								//$idtmpObj=Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", statuteSender=1, statuteRecipient=1, `_idRecipient`=".$tmpPersonObj->_id.$options."",true);
								// RECUPERATION ID MESSAGE
								$idtmpObj=Db::getval("SELECT `_id` FROM ".MdlMessage::dbTable." WHERE `_idSender`=".Ctrl::$curUser->_id." AND `object`=".Db::formatParam("object")." AND `description`=".Db::formatParam("description","editor")." AND `dateCrea`=".Db::dateNow()." AND `statute`=1 AND `_idRecipient`=".$tmpPersonObj->_id."");
								Db::query("UPDATE ".MdlMessage::dbTable." SET `_idMessageSender`=".$idtmpObj." WHERE `_id`=".$idtmpObj."");
								// ENREGISTREMENT TABLE MESSAGE PREMIER DESTINATAIRE
								Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idMessageSender`=".$idtmpObj.", `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=2, `_idRecipient`=".$tmpPersonObj->_id.$options."");
							}
							else
							{
								// ENREGISTREMENT TABLE MESSAGE DESTINATAIRES
								Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idMessageSender`=".$idtmpObj.", `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=2, `_idRecipient`=".$tmpPersonObj->_id.$options."");
							}
						}
					
						////	FICHIERS JOINTS
						if(!empty($_FILES))
						{
							//	LIMITE A UN DEPOT
							if ($cptPerson==1)
							{
								foreach($_FILES as $tmpFile)
								{
									$sqlVersionFileName=null;
									//	CONTROLE DU FICHIER (NOM)
									if(!empty($tmpFile["name"]))
									{
										// ENREGISTREMENT DU FICHIER DANS LES TABLES AP_MESSAGE ET AP_MESSAGEFILE
										$sqlVersionFileName=$idtmpObj."_".time().rand(1,100).".".File::extension($tmpFile["name"]);
										Db::query("INSERT INTO ".MdlMessage::dbTablefile." SET _idMessage=".$idtmpObj.", realName=".Db::format($tmpFile["name"]).", fileName=".Db::format($sqlVersionFileName).", _idUser=".Ctrl::$curUser->_id."");
									
										// DEPOT DU FICHIER DANS DATAS
										$uploadfile=MdlMessage::moduleDataDir.$sqlVersionFileName;
										move_uploaded_file($tmpFile['tmp_name'], $uploadfile);
										//File::setChmod($tmpObj->filePath());
									}
								}
							}
							
							// MISE A JOUR DES ID FICHIERS TABLE AP_MESSAGE
							$idFiles=array();
							$idFiles=Db::getTab("SELECT `_id` from ".MdlMessage::dbTablefile." WHERE _idMessage=".$idtmpObj."");
							$idFilesdb='';
							foreach ($idFiles as $id_tmp)
							{
								$idFilesdb=$idFilesdb."@".$id_tmp['_id'];
							}
							Db::query("UPDATE ".MdlMessage::dbTable." SET `_idfilename`='".$idFilesdb."' WHERE `_idMessageSender`=".$idtmpObj."");
						}
						// TRANSFERT DE FICHIER(S)
						if(Req::getParam("joinfile"))
						{
							// LIMITE A UNE ACTION
							if ($cptPerson==1)
							{
								$cptjoinFile=0;
								// RECUPERATION ET TRAITTEMENTS DES FICHEIRS AVEC ID VIA URL GET
								$array_IdjoinFiles=explode("@",Req::getParam("joinfile"));
								foreach($array_IdjoinFiles as $idjoinFile_tmp)
								{
									if ($cptjoinFile>0)
									{
										// PREPARE LES INFOS DU FICHIER
										$Filenamedb=Db::getVal("SELECT `filename` from ".MdlMessage::dbTablefile." WHERE `_id`=".$idjoinFile_tmp."");
										$sqlFileName=$idtmpObj."_".time().rand(1,100).".".File::extension($Filenamedb);
										// DUPLIQUE LE FICHIER
										copy(MdlMessage::moduleDataDir.$Filenamedb,MdlMessage::moduleDataDir.$sqlFileName);
										// PISE A JOUR TABLE AP MESSAGE FILE
										$newidfile_tmp=Db::query("INSERT INTO ".MdlMessage::dbTablefile." (`_idContainer`, `realName`, `octetSize`, `dateCrea`, `_idUser`) SELECT `_idContainer`, `realName`, `octetSize`, `dateCrea`, `_idUser` FROM ".MdlMessage::dbTablefile." WHERE `_id`=".$idjoinFile_tmp."",true);
										Db::query("UPDATE ".MdlMessage::dbTablefile." SET `_idMessage`=".$idtmpObj.", `filename`='".$sqlFileName."' WHERE `_id`=".$newidfile_tmp."");
									}
									$cptjoinFile++;
								}
							}
							// MISE A JOUR DES ID FICHIERS NOUVEAU ET TRANSFERER TABLE AP_MESSAGE
							$idFilesforward=array();
							$idFilesforward=Db::getTab("SELECT `_id` from ".MdlMessage::dbTablefile." WHERE _idMessage=".$idtmpObj."");
							$idFilesforwarddb='';
							foreach ($idFilesforward as $idforward_tmp)
							{
								$idFilesforwarddb=$idFilesforwarddb."@".$idforward_tmp['_id'];
							}
							Db::query("UPDATE ".MdlMessage::dbTable." SET `_idfilename`='".$idFilesforwarddb."' WHERE `_idMessageSender`=".$idtmpObj."");
						}
					}
				
					// MISE A JOUR TABLE DESTINATAIRES
					$idDestinataires=array();
					$idDestinataires=Db::getTab("SELECT _idRecipient from ".MdlMessage::dbTable." WHERE `_idMessageSender`=".$idtmpObj." AND _id <> ".$idtmpObj."");
					$idtmpDestinataires='';
					$idDestinatairesdb='';
					foreach ($idDestinataires as $idtmpDestinataires)
					{
						$idDestinatairesdb=$idDestinatairesdb."@".$idtmpDestinataires['_idRecipient'];
					}
					//Db::query("UPDATE ".MdlMessage::dbTable." SET recipients='".$idDestinatairesdb."' WHERE `_id`=".$idtmpObj."");
					Db::query("UPDATE ".MdlMessage::dbTable." SET recipients='".$idDestinatairesdb."' WHERE `_idMessageSender`=".$idtmpObj."");							
				}
			
				// Liste des users de groupe
				if(Req::isParam("groupList"))
				{
					// INIT
					$cptPerson=0;
					$idtmpObj=null;
					$idtmpObj1=null;
					$idtmpDestinataires=null;
					
					foreach(Req::getParam("groupList") as $tmpGroup)
					{
						$cptPerson++;
						//	RECUPERATION INFO USER
						$tmpGroupObj=Ctrl::getTargetObj($tmpGroup);
						
						// OPTIONS
						//if ($cptPerson==1) {$options=$options.",_idFirstRecipient=".$tmpPersonObj->_id;}
					
						if(is_object($tmpGroupObj))
						{
							foreach($tmpGroupObj->userIds as $tmpUserId)
							{
								$tmpUser=Ctrl::getObj("user",$tmpUserId);
								
								////	ENVOI DEPUIS BROUILLONS
								if(Req::getParam("ObjId"))
								{
									if ($cptPerson==1)
									{
										// ENREGISTREMENT TABLE MESSAGE EXPEDITEUR
										$idtmpObj=Req::getParam("ObjId");
										Db::query("UPDATE ".MdlMessage::dbTable." SET `_idMessageSender`=".$idtmpObj.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=1, `_idRecipient`=".$tmpUser->_id.$options." WHERE `_id`=".Req::getParam("ObjId")."");
										// ENREGISTREMENT TABLE MESSAGE PREMIER DESTINATAIRE
										Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idMessageSender`=".$idtmpObj.", `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=2, `_idRecipient`=".$tmpUser->_id.$options."");
									}
									else
									{
										//	ENREGISTREMENT TABLE MESSAGE DESTINATAIRES
										Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idMessageSender`=".$idtmpObj.", `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=2, `_idRecipient`=".$tmpUser->_id.$options."");
									}
								}
								
								////	ENVOI DEPUIS MESSSAGENEW.PHP
								else
								{
									if ($cptPerson==1)
									{
										// ENREGISTREMENT TABLE MESSAGE EXPEDITEUR
										Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=1, `_idRecipient`=".$tmpUser->_id.$options."");
										//$idtmpObj=Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", statuteSender=1, statuteRecipient=1, `_idRecipient`=".$tmpPersonObj->_id.$options."",true);
										// RECUPERATION ID MESSAGE
										$idtmpObj=Db::getval("SELECT _id FROM ".MdlMessage::dbTable." WHERE `_idSender`=".Ctrl::$curUser->_id." AND `object`=".Db::formatParam("object")." AND `description`=".Db::formatParam("description","editor")." AND `dateCrea`=".Db::dateNow()." AND `statute`=1 AND `_idRecipient`=".$tmpUser->_id."");
										Db::query("UPDATE ".MdlMessage::dbTable." SET `_idMessageSender`=".$idtmpObj." WHERE `_id`=".$idtmpObj."");
										// ENREGISTREMENT TABLE MESSAGE PREMIER DESTINATAIRE
										Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idMessageSender`=".$idtmpObj.", `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=2, `_idRecipient`=".$tmpUser->_id.$options."");
									}
									else
									{
										// ENREGISTREMENT TABLE MESSAGE DESTINATAIRES
										Db::query("INSERT INTO ".MdlMessage::dbTable." SET `_idMessageSender`=".$idtmpObj.", `_idSender`=".Ctrl::$curUser->_id.", `object`=".Db::formatParam("object").", `description`=".Db::formatParam("description","editor").", `dateCrea`=".Db::dateNow().", `statute`=2, `_idRecipient`=".$tmpUser->_id.$options."");
									}
								}
								
								////	FICHIERS JOINTS
								if(!empty($_FILES))
								{
									//	LIMITE A UN DEPOT
									if ($cptPerson==1)
									{
										$sqlVersionFileName=null;
										foreach($_FILES as $tmpFile)
										{
											//	CONTROLE DU FICHIER (NOM)
											if(!empty($tmpFile["name"]))
											{
												// ENREGISTREMENT DU FICHIER DANS LES TABLES AP_MESSAGE ET AP_MESSAGEFILE
												$sqlVersionFileName=$idtmpObj."_".time().rand(1,100).".".File::extension($tmpFile["name"]);
												Db::query("INSERT INTO ".MdlMessage::dbTablefile." SET `_idMessage`=".$idtmpObj.", `realName`=".Db::format($tmpFile["name"]).", fileName=".Db::format($sqlVersionFileName).", _idUser=".Ctrl::$curUser->_id."");
												
												// DEPOT DU FICHIER DANS DATAS
												$uploadfile=MdlMessage::moduleDataDir.$sqlVersionFileName;
												move_uploaded_file($tmpFile['tmp_name'], $uploadfile);
												//File::setChmod($tmpObj->filePath());
											}
										}
									}
										
									// MISE A JOUR DES ID FICHIERS TABLE AP_MESSAGE
									$idFiles=array();
									$idFiles=Db::getTab("SELECT `_id` from ".MdlMessage::dbTablefile." WHERE _idMessage=".$idtmpObj."");
									$idFilesdb='';
									foreach ($idFiles as $id_tmp)
									{
										$idFilesdb=$idFilesdb."@".$id_tmp['_id'];
									}
									Db::query("UPDATE ".MdlMessage::dbTable." SET `_idfilename`='".$idFilesdb."' WHERE `_idMessageSender`=".$idtmpObj."");
								}
									
								// TRANSFERT DE FICHIER(S)
								if(Req::getParam("joinfile"))
								{
									// LIMITE A UNE ACTION
									if ($cptPerson==1)
									{
										$cptjoinFile=0;
										// RECUPERATION ET TRAITTEMENTS DES FICHEIRS AVEC ID VIA URL GET
										$array_IdjoinFiles=explode("@",Req::getParam("joinfile"));
										foreach($array_IdjoinFiles as $idjoinFile_tmp)
										{
											if ($cptjoinFile>0)
											{
												// PREPARE LES INFOS DU FICHIER
												$Filenamedb=Db::getVal("SELECT `filename` from ".MdlMessage::dbTablefile." WHERE `_id`=".$idjoinFile_tmp."");
												$sqlFileName=$idtmpObj."_".time().rand(1,100).".".File::extension($Filenamedb);
												// DUPLIQUE LE FICHIER
												copy(MdlMessage::moduleDataDir.$Filenamedb,MdlMessage::moduleDataDir.$sqlFileName);
												// MISE A JOUR TABLE AP MESSAGE FILE
												$newidfile_tmp=Db::query("INSERT INTO ".MdlMessage::dbTablefile." (`_idContainer`, `realName`, `octetSize`, `dateCrea`, `_idUser`) SELECT `_idContainer`, `realName`, `octetSize`, `dateCrea`, `_idUser` FROM ".MdlMessage::dbTablefile." WHERE `_id`=".$idjoinFile_tmp."",true);
												Db::query("UPDATE ".MdlMessage::dbTablefile." SET `_idMessage`=".$idtmpObj.", `filename`='".$sqlFileName."' WHERE `_id`=".$newidfile_tmp."");
											}
											$cptjoinFile++;
										}
									}
									
									// MISE A JOUR DES ID FICHIERS NOUVEAU ET TRANSFERER TABLE AP_MESSAGE
									$idFilesforward=array();
									$idFilesforward=Db::getTab("SELECT `_id` from ".MdlMessage::dbTablefile." WHERE _idMessage=".$idtmpObj."");
									$idFilesforwarddb='';
									foreach ($idFilesforward as $idforward_tmp)
									{
										$idFilesforwarddb=$idFilesforwarddb."@".$idforward_tmp['_id'];
									}		
									Db::query("UPDATE ".MdlMessage::dbTable." SET `_idfilename`='".$idFilesforwarddb."' WHERE `_idMessageSender`=".$idtmpObj."");
								}
							}
				
							// MISE A JOUR TABLE DESTINATAIRES
							$idDestinataires=array();
							$idDestinataires=Db::getTab("SELECT `_idRecipient` from ".MdlMessage::dbTable." WHERE `_idMessageSender`=".$idtmpObj." AND `_id` <> ".$idtmpObj."");
							$idtmpDestinataires='';
							$idDestinatairesdb='';
							foreach ($idDestinataires as $idtmpDestinataires)
							{
								$idDestinatairesdb=$idDestinatairesdb."@".$idtmpDestinataires['_idRecipient'];
							}
							Db::query("UPDATE ".MdlMessage::dbTable." SET `recipients`='".$idDestinatairesdb."' WHERE `_id`=".$idtmpObj."");							
				
						}
					}
				}
			}
			
			// RETOUR A LA PAGE INDEX.PHP APRES ENVOI DU MESSAGE
			self::redir('index.php?ctrl=message&target=sendbox');
		}
	}
	
	/*
	 * ACTION messageDelete() : PLACEMENT DU MESSAGE DANS LA CORBEILLE (STATUTE : 3/4/DELETE)
	 * DEPUIS MENU EDIT ET LIGHTBOX MESSAGE
	*/
	public function actionmessageDelete()
	{
		$MainPage=false;
		$target=Req::getParam("target");
		$MainPage=Req::getParam("mainpage");
		$curObj=Ctrl::getTargetObj();
		$curObj->controlRead();
		$vDatas["curObj"]=$curObj;
		
		// STATUTE 4 : BIN ou STATUTE 5 : ATTENTE DE SUPPRESSION
		$statute_value=4;
		if ($target=="bin") {$statute_value=5;}
		
		// MISE A JOUR TABLE CHAMP STATUTE
		Db::query("UPDATE ".MdlMessage::dbTable." SET `statute`=".$statute_value." WHERE `_id`=".$curObj->_id."");
		
		// EN TEST
		////	VIDAGE DE LA TABLE DU MESSAGE SUPPRIME ET FICHIER(S) JOINT(S) DE LA CORBEILLE EXPEDITEUR ET DESTINATAIRE
		
		// EXPEDITEUR
		$statuteSender=null;
		If(($curObj->_id)==($curObj->_idMessageSender))
		{
			// INIT
			$nbidjoinfile=null;
			// RECHARGE STATUTE
			$statuteSender=Db::getVal("SELECT `statute` FROM ".MdlMessage::dbTable." WHERE `_id`=".$curObj->_id." AND `_idMessageSender`=".$curObj->_id." AND `_idSender`=".Ctrl::$curUser->_id."");
			// BROUILLON (STATUTE 0)
			If ($statuteSender==0)
			{
				$curObj->delete();
			}
			// SENDBOX (STATUTE 5)
			elseIf ($statuteSender==5)
			{
				// DESTINATAIRE EN ATTENTE DE SUPPRESSION (STATUT 5)
				$statute_Recipients=Db::getTab("SELECT * FROM ".MdlMessage::dbTable." WHERE `_id` <> ".$curObj->_id." AND `_idMessageSender`=".$curObj->_id."");
				foreach ($statute_Recipients as $statute_Recipient_tmp)
				{
					If ($statute_Recipient_tmp['statute']==5)
					{
						Db::query("DELETE FROM ".MdlMessage::dbTable." WHERE `_id`=".$statute_Recipient_tmp['_id']." AND `_idSender`=".Ctrl::$curUser->_id."");
					}
				}
				
				// SUPPRESSION DES FICHIERS JOINTS
				if(!empty($curObj->_idfilename))
				{
					$nbidjoinfile=count(Db::getTab("SELECT * FROM `".MdlMessage::dbTable."` WHERE `_idfilename`='".$curObj->_idfilename."' AND `_idMessageSender`=".$curObj->_id." AND `_id` <> ".$curObj->_id.""));
					if($nbidjoinfile==0) 
					{
						$array_IdFiles=explode("@",$curObj->_idfilename);
						$cpt=0;
						$deleteResult=false;
						foreach($array_IdFiles as $idtmp)
						{
							if ($cpt!=0)
							{
								$filename=Db::getVal("SELECT `filename` FROM ".MdlMessage::dbTablefile." WHERE `_id`=".$idtmp."");
								$deleteResult=File::rm(MdlMessage::moduleDataDir.$filename);
								if($deleteResult==true)   {Db::query("DELETE FROM ".MdlMessage::dbTablefile." WHERE `_id`=".$idtmp." AND `_idUser` = ".Ctrl::$curUser->_id."");}
							}
							$cpt++;
						}
					}
				}
				
				// SUPPRESSION MESSAGE
				$curObj->delete();
			}
		}
		else
		// DESTINATAIRE
		{
			$statuteSender=Db::getVal("SELECT `statute` FROM ".MdlMessage::dbTable." WHERE `_id`=".$curObj->_idMessageSender."");
			$statuteRecipient=Db::getVal("SELECT `statute` FROM ".MdlMessage::dbTable." WHERE `_id`=".$curObj->_id." AND `_idRecipient`=".Ctrl::$curUser->_id."");
			// CAS 1 : MESSAGE EXPEDITEUR DEJA SUPPRIME
			If ((empty($statuteSender))&&($statuteRecipient==5)) 
			{
				// SUPPRRESSION FICHIERS JOINTS
				if(!empty($curObj->_idfilename))
				{
					$nbidjoinfile=count(Db::getTab("SELECT * FROM ".MdlMessage::dbTable." WHERE `_idfilename`='".$curObj->_idfilename."' AND `_id` <> ".$curObj->_id.""));
					if($nbidjoinfile==0)
					{
						$array_IdFiles=explode("@",$curObj->_idfilename);
						$cpt=0;
						//$deleteResult=false;
						foreach($array_IdFiles as $idtmp)
						{
							if ($cpt>0)
							{
								$filename=Db::getVal("SELECT `filename` FROM ".MdlMessage::dbTablefile." WHERE `_id`=".$idtmp."");
								$deleteResult=File::rm(MdlMessage::moduleDataDir.$filename);
								if($deleteResult==true)   {Db::query("DELETE FROM ".MdlMessage::dbTablefile." WHERE `_id`=".$idtmp." AND `_idUser`=".$curObj->_idSender."");}
							}
							$cpt++;
						}
					}
				}
				
				// SUPPRRESSION DU MESSAGE
				$curObj->delete();
			}
		}
			
		//FERME LA LIGHTBOX ET REDIRIGE
		if($MainPage!=true){static::lightboxClose();}
		self::redir('index.php?ctrl=message&target='.$target.'');
	}
	
	/*
	  * ACTION Delete() : TRAITEMENT PAR LOT DEPUIS MENU GAUCHE - PLACEMENT DU MESSAGE DANS LA CORBEILLE (STATUTE : 3/4/DELETE)
	*/
	public static function actionDelete()
	{
		//// INIT
		$target=Req::getParam("target");
		//$notDeletedObjects=[];
		//// SUPPRESSION DU/DES MESSAGES
		foreach(self::getTargetObjects() as $tmpObj)
		{
			// STATUTE 4 : BIN OU 5 : ATTENTE DE SUPPRESSION
			if ($target=="bin") {$statute_value=5;} else {$statute_value=4;}
			// MISE A JOUR TABLE
			Db::query("UPDATE ".MdlMessage::dbTable." SET `statute`=".$statute_value." WHERE `_id`=".$tmpObj->_id);
			
			//	VIDAGE DE LA TABLE DU MESSAGE SUPPRIME ET FICHIER(S) JOINT(S) DE LA CORBEILLE EXPEDITEUR ET DESTINATAIRE
		
			// EXPEDITEUR
			$statuteSender=null;
			If(($tmpObj->_id)==($tmpObj->_idMessageSender))
			{
				// INIT
				$nbidjoinfile=null;
				// RECHARGE STATUTE
				$statuteSender=Db::getVal("SELECT `statute` FROM ".MdlMessage::dbTable." WHERE `_id`=".$tmpObj->_id." AND `_idMessageSender`=".$tmpObj->_id." AND `_idSender`=".Ctrl::$curUser->_id."");
				// DRAFTS (STATUTE 0)
				If ($statuteSender==0)
				{
					$tmpObj->delete();
				}
				// SENDBOX (STATUTE 5)
				elseIf ($statuteSender==5)
				{
					// DESTINATAIRE EN ATTENTE DE SUPPRESSION (STATUTE 5)
					$statute_Recipients=Db::getTab("SELECT * FROM ".MdlMessage::dbTable." WHERE `_id` <> ".$tmpObj->_id." AND `_idMessageSender`=".$tmpObj->_id."");
					foreach ($statute_Recipients as $statute_Recipient_tmp)
					{
						If ($statute_Recipient_tmp['statute']==5)
						{
							Db::query("DELETE FROM ".MdlMessage::dbTable." WHERE `_id`=".$statute_Recipient_tmp['_id']." AND `_idSender`=".Ctrl::$curUser->_id."");
						}
					}
				
					// SUPPRESSION DES FICHIERS JOINTS
					if(!empty($tmpObj->_idfilename))
					{
						$nbidjoinfile=count(Db::getTab("SELECT * FROM `".MdlMessage::dbTable."` WHERE `_idfilename`='".$tmpObj->_idfilename."' AND `_idMessageSender`=".$tmpObj->_id." AND `_id` <> ".$tmpObj->_id.""));
						if($nbidjoinfile==0) 
						{
							$array_IdFiles=explode("@",$tmpObj->_idfilename);
							$cpt=0;
							$deleteResult=false;
							foreach($array_IdFiles as $idtmp)
							{
								if ($cpt>0)
								{
								$filename=Db::getVal("SELECT `filename` FROM ".MdlMessage::dbTablefile." WHERE `_id`=".$idtmp."");
								$deleteResult=File::rm(MdlMessage::moduleDataDir.$filename);
								if($deleteResult==true)   {Db::query("DELETE FROM ".MdlMessage::dbTablefile." WHERE `_id`=".$idtmp." AND `_idUser`=".Ctrl::$curUser->_id."");}
								}
								$cpt++;
							}
						}
					}
				
					// SUPPRESSION MESSAGE
					$tmpObj->delete();
				}
		}
		else
		// DESTINATAIRE
		{
			$statuteSender=Db::getVal("SELECT `statute` FROM ".MdlMessage::dbTable." WHERE `_id`=".$tmpObj->_idMessageSender."");
			$statuteRecipient=Db::getVal("SELECT `statute` FROM ".MdlMessage::dbTable." WHERE `_id`=".$tmpObj->_id." AND `_idRecipient`=".Ctrl::$curUser->_id."");
			
				//// MESSAGE EXPEDITEUR DEJA SUPPRIME
				If ((empty($statuteSender))&&($statuteRecipient==5)) 
				{
					// SUPPRRESSION FICHIERS JOINTS
					if(!empty($tmpObj->_idfilename))
					{
						$nbidjoinfile=count(Db::getTab("SELECT * FROM ".MdlMessage::dbTable." WHERE `_idfilename`='".$tmpObj->_idfilename."' AND `_id` <> ".$tmpObj->_id.""));
						if($nbidjoinfile==0)
						{
							$array_IdFiles=explode("@",$tmpObj->_idfilename);
							$cpt=0;
							$deleteResult=false;
							foreach($array_IdFiles as $idtmp)
							{
								if ($cpt!=0)
								{
									$filename=Db::getVal("SELECT `filename` FROM ".MdlMessage::dbTablefile." WHERE `_id`=".$idtmp."");
									$deleteResult=File::rm(MdlMessage::moduleDataDir.$filename);
									if($deleteResult==true)   {Db::query("DELETE FROM ".MdlMessage::dbTablefile." WHERE `_id`=".$idtmp." AND `_idUser`=".$tmpObj->_idSender."");}
								}
								$cpt++;
							}
						}
					}
				
					// SUPPRRESSION DU MESSAGE
					$tmpObj->delete();
				}
			}
		}
		
		// REDIRECTION
		self::redir('index.php?ctrl=message&target='.$_GET['target'].'');
			
	}
	
	/*
	 * ACTION messageArchive() : PLACEMENT DU MESSAGE DANS ARCHIVES STATUTE : 3
	*/
	public function actionmessageArchive()
	{
		// INIT
		$MainPage=false;
		$target=Req::getParam("target");
		$MainPage=Req::getParam("mainpage");
		$curObj=Ctrl::getTargetObj();
		$curObj->controlRead();
		$vDatas["curObj"]=$curObj;
		
		// MISE A JOUR TABLE
		Db::query("UPDATE ".MdlMessage::dbTable." SET `statute`=3 WHERE `_id`=".$curObj->_id."");
		
		// FERME LA LIGHTBOX SI NECESSAIRE
		if($MainPage!=true){static::lightboxClose();}
		
		// REDIRECTION
		self::redir('index.php?ctrl=message&target='.$target.'');
	}

	/*
	 * ACTION Archive() : TRAITEMENT PAR LOT DEPUIS MENU GAUCHE - PLACEMENT DU MESSAGE DANS ARCHIVES STATUTE : 3
	*/
	public static function actionArchive()
	{
		// INIT
		$target=Req::getParam("target");
		// Archives les messages
		foreach(self::getTargetObjects() as $tmpObj)
		{
			// MISE A JOUR TABLE
			Db::query("UPDATE ".MdlMessage::dbTable." SET `statute`=3 WHERE `_id`=".$tmpObj->_id."");
		}
		// REDIRECTION
		self::redir('index.php?ctrl=message&target='.$target.'');
	}
	
	/*
	 * ACTION Getfile() : TELECHARGEMENT DU FICHIER DANS DATAS
	*/
	public static function actionGetFile()
	{
		if(Req::isParam("targetfileId"))
		{
			// RECUPERE LES INFOS DU FICHIERS VIA ID
			$targetfileId=Req::getParam("targetfileId");
			$filename=Db::getVal("SELECT `filename` FROM ".MdlMessage::dbTablefile." WHERE `_id`=".$targetfileId."");
			$realName=Db::getVal("SELECT realName FROM ".MdlMessage::dbTablefile." WHERE `_id`=".$targetfileId."");
			
			// TELECHAGEMENT DU FICHIER
			File::download($realName, MdlMessage::moduleDataDir.$filename);
		}
	}

	/*
	 * ACTION Restore : PLACEMENT DU MESSAGE DANS SENDBOX/INBOX STATUTE : 1 OU 2
	*/
	public function actionmessageRestore()
	{
		//	INIT
		$statute_tmp=null;
		$MainPage=false;
		$target=Req::getParam("target");
		$MainPage=Req::getParam("mainpage");
		
		//	RECUPERE LE MESSAGE
		$curObj=Ctrl::getTargetObj();
		$curObj->controlRead();
		$vDatas["curObj"]=$curObj;
		
		// TEST EXPEDITEUR/DESTINATAIRE
		If(($curObj->_id)==($curObj->_idMessageSender))
		{
			// BROUILLON	
			If(($curObj->_idRecipient)==0)
			{$statute_tmp=0;}
			// SENDBOX	
			else
			{$statute_tmp=1;}
		}
		else
		{$statute_tmp=2;}
		// MISE A JOUR TABLE
		Db::query("UPDATE ".MdlMessage::dbTable." SET `statute`=".$statute_tmp." WHERE `_id`=".$curObj->_id);
		
		// FERME LA LIGHTBOX SI NECESSAIRE
		if($MainPage!=true){static::lightboxClose();}
		// REDIRECTION
		self::redir('index.php?ctrl=message&target='.$target.'');
	}
	
	/*
	 * ACTION Restore() (TRAITEMENT PAR LOT DEPUIS MENU GAUCHE) : PLACEMENT DU MESSAGE DANS INBOX/SENDBOX
	*/
	public function actionRestore()
	{
		//	INIT
		$statute_tmp=null;
		$target=Req::getParam("target");

		foreach(self::getTargetObjects() as $tmpObj)
		{
			// TEST EXPEDITEUR/DESTINATAIRE
			If(($tmpObj->_id)==($tmpObj->_idMessageSender))
			{
				// BROUILLON	
				If(($tmpObj->_idRecipient)==0)
				{$statute_tmp=0;}
				// SENDBOX	
				else
				{$statute_tmp=1;}
			}
			else
			{$statute_tmp=2;}
			// MISE A JOUR TABLE
			Db::query("UPDATE ".MdlMessage::dbTable." SET `statute`=".$statute_tmp." WHERE `_id`=".$tmpObj->_id);
		}
		
		// REDIRECTION
		self::redir('index.php?ctrl=message&target='.$target.'');
	}

	/*
	 * ACTION messageinabottle() : AFFICHAGE DE LA PAGE POUR ENVOI DU MESSAGE OU DU BROUILLON
	*/
	public function actionmessageinabottle()
	{
		//	INIT
		static::$isMainPage=true;
		// INIT POUR TRANSFERT
		$forward=null;
		$vDatas["forward"]=null;
		$forward=Req::getParam("forward");
		$vDatas["infofile"]="";
		
		
			//	BROUILLONS OU TRANSFERT
			if(Req::getParam("targetObjId"))
			{
				$curObj=Ctrl::getTargetObj();
				$curObj->controlRead();
				$vDatas["curObj"]=$curObj;
				if($forward=="yes")
				{
					$recipients=$curObj->getNameFirstNameSender();
					$vDatas["forward"]="<p></p><p><b>-----------".Txt::trad("MESSAGE_forward_message1")."-----------</b></p><p><i>Envoyé par <b>".$recipients."</b> le <b>".Txt::formatDate($curObj->dateCrea,"dbDatetime","inputDatetime")."</b></i></p><br/>".$curObj->description."<p><br/><b>------".Txt::trad("MESSAGE_forward_message2")."-------</b></p>";
				}
				$vDatas["infofile"]="<br/><div class='lightboxTitle'>".$curObj->getInfoFile()."</div>";
			}
			//	NOUVEAU MESSAGE
			else
			{
				$vDatas["curObj"]=null;
				$vDatas["forward"]=null;
			}
		
		//	LISTE DES ESPACES ET UTILISATEURS ASSOCIES
		foreach(Ctrl::$curUser->getSpaces() as $tmpContainer)
		{
			$tmpContainer->personList=$tmpContainer->getUsers();
			if(!empty($tmpContainer->personList))  {$vDatas["containerList"][]=$tmpContainer;}
		}
		
		//	AFFICHAGE DE VueMessageinabottle.php
		static::displayPage("VueMessageinabottle.php",$vDatas);
	}
	
	/*
	 * ACTION messageforward() : TRANSFERT DE MESSAGE
	*/
	public function actionmessageforward()
	{
		//	INIT
		static::$isMainPage=false;
		//	RECUPERATION DES INFOS MESSAGE
		$curObj=Ctrl::getTargetObj();
		$curObj->controlRead();
		//	REDIRECTION
		self::redir('index.php?ctrl=message&targetObjId=message-'.$curObj->_id.'&action=messageinabottle&forward=yes');
	}
	
	/*
	 * ACTION messageanswer() : REPONSE A UN/PLUSIEURS DESTINATAIRE DU MESSAGE
	*/
	public function actionmessageanswer()
	{
		//	INIT
		$inputrecipients=null;
		$all="no";
		$all=Req::getParam("all");
		//	RECUPERATION DES INFOS MESSAGE
		$curObj=Ctrl::getTargetObj();
		$curObj->controlRead();
		$vDatas["curObj"]=$curObj;
		
		////	REPONDRE OU REPONDRE A TOUS	
		// REPONDRE A TOUS
		if($all=="yes")
		{
			//	NOMBRE DE DESTINATAIRES
			$IdRecipients=Db::getVal("SELECT `recipients` FROM ".MdlMessage::dbTable." WHERE `_id`=".$curObj->_id);
			$array_IdRecipients=explode("@",$IdRecipients);
			$cpt=0;
			
			$inputRecipients="<input type=\"hidden\" name=\"personList[]\" value=\"user-".$curObj->_idSender."\" />";
			foreach($array_IdRecipients as $id_tmp)
			{
				if ($cpt!=0) 
				{
					if((Ctrl::$curUser->_id)!=$id_tmp) {$inputRecipients=$inputRecipients."<input type=\"hidden\" name=\"personList[]\" value=\"user-".$id_tmp."\" />";}
				}
				$cpt++;
			}
			$Recipients=$curObj->getNameFirstNameSender().", ".$curObj->getRecipients('hideUser');
		}
		// REPONDRE
		elseif($all=="no")
		{
			$Recipients=$curObj->getNameFirstNameSender();
			$inputRecipients="<input type=\"hidden\" name=\"personList[]\" value=\"user-".$curObj->_idSender."\" />";
		}
				
		$vDatas["inputRecipients"]=$inputRecipients;
		$vDatas["Recipients"]=$Recipients;
		
		// AFFICHAGE MESSAGE ENVOYE
		$Sender=$curObj->getNameFirstNameSender();
		$vDatas["answer"]=$inputrecipients."<p></p><p><b>-----------".Txt::trad("MESSAGE_answer_message1")."-----------</b></p><p><i><b>".$Sender."</b> a écrit le <b>".Txt::formatDate($curObj->dateCrea,"dbDatetime","inputDatetime")."</b></i></p><br/>".$curObj->description."<p><br/><b>------".Txt::trad("MESSAGE_answer_message2")."-------</b></p>";
		
		// AFFICHAGE DE LA PAGE
		static::displayPage("VueMessageanswer.php",$vDatas);
	}	
}